import es
import playerlib
import shelve
import time

info = es.AddonInfo()
info['name']        = "SimpleRanks"
info['version']     = "2.0"
info['author']      = "3R10N"
info['url']         = "http://addons.eventscripts.com/addons/view/simpleranks"
info['description'] = "A simple ranking system that counts your kills and deaths"

es.ServerVar('simpleranks', info['version'], 'SimpleRanks made by 3R10N').makepublic() 

sr_stats = shelve.open(es.getAddonPath('simpleranks') + '/data.db', writeback=True) 

def load(): 
  es.regsaycmd('!stats','simpleranks/simp_stats_send')
  es.regsaycmd('!kdr','simpleranks/simp_kdr_send')
  for userid in es.getUseridList(): 
      player_spawn({'userid':str(userid)}) 


def es_map_start(event_var): 
   sr_stats.sync() 


def player_spawn(event_var): 
   global sr_stats 

   userid = event_var['userid'] 
   simp_uid = playerlib.uniqueid(userid, True) 
   if sr_stats.has_key(simp_uid): 
      sr_stats[simp_uid]['connection_time'] = time.time() 
   else: 
      sr_stats[simp_uid] = {'kills':0, 'deaths':0, 'connection_time':time.time()} 

def player_death(event_var): 
   global sr_stats 

   if event_var['es_userteam'] != event_var['es_attackerteam']: 
      simp_uid_temp = event_var['userid'] 
      simp_uid = playerlib.uniqueid(simp_uid_temp, True) 
      sr_stats[simp_uid]['deaths'] += 1 

      simp_aid_temp = event_var['attacker'] 
      simp_aid = playerlib.uniqueid(simp_aid_temp, True) 
      sr_stats[simp_aid]['kills'] += 1

def simp_stats_send():
   simp_cuid_temp = es.getcmduserid()
   simp_cuid = playerlib.uniqueid(simp_cuid_temp, True)
   es.tell(simp_cuid_temp, '#multi', '#defaultYou have #green%(kills)s kills#default and #lightgreen%(deaths)s deaths#default.' % sr_stats[simp_cuid])

def simp_kdr_send():
   simp_cuid_temp = es.getcmduserid()
   simp_cuid = playerlib.uniqueid(simp_cuid_temp, True)
   simp_kills = sr_stats[simp_cuid]['kills']
   simp_deaths = sr_stats[simp_cuid]['deaths']
   simp_kdr = simp_kills / simp_deaths
   es.tell(simp_cuid_temp, '#multi', '#defaultYour#green kill#lightgreen-death ratio is#default %s' % round(simp_kdr, 2))
   
def unload(): 
   sr_stats.close()